;-----------------------------------------------------------------------;
;	Replay 								;
;	Copyright (C) Karl Anders ygard, 15 December 1993		;
;-----------------------------------------------------------------------;
; Called by the replay routine for the specific machine type.		;
;-----------------------------------------------------------------------;

vfreq		EQU 50

;-------------------------------------------- Hispeed sampleformatter --
mt_prepare:	lea	mt_data(pc),a2
		adda.l	mt_totalsize(pc),a2

		movea.l	mt_samplestarts(pc),a0
		movea.l	mt_end_of_samples(pc),a1

mt_tostack:	move.w	-(a1),-(a2)
		cmpa.l	a0,a1			; Move all samples to stack
		bgt.s	mt_tostack

		lea	mt_samplestarts(pc),a5
		lea	mt_data(pc),a1		; Module

		moveq	#30,d0
mt_roop:	move.w	d0,-(sp)

		moveq	#0,d0
		move.w	$2a(a1),d0
		add.l	d0,d0
		pea	0(a2,d0.l)

		move.l	a0,(a5)+
		move.l	a0,$26(a1)

		tst.w	$2a(a1)
		beq.s	mt_samplok		; Len=0 -> no sample

		tst.w	$2E(a1)			; Test repstrt
		bne.s	repne			; Jump if not zero

		move.w	$2a(a1),d0		; Length of sample
		cmp.w	$30(a1),d0
		beq.s	repne

		move.l	d0,d4
		movea.l	a0,a4
		bra.s	mt_frstkent
mt_fromstk:	move.w	(a2)+,(a0)+		; Move all samples back from stack
mt_frstkent:	dbra	d0,mt_fromstk

		bra.s	rep


repne:		move.w	$2E(a1),d0		; Repstart

		move.l	d0,d4
		bra.s	mt_getent
mt_get1st:	move.w	(a2)+,(a0)+		; Fetch first part
mt_getent:	dbra	d0,mt_get1st
		movea.l	a2,a4


rep:		movea.l	a0,a2			; For the safety bytes

		moveq	#0,d1
mt_toosmal:	movea.l	a4,a3
		move.w	$30(a1),d0

		subq.w	#1,d0
mt_moverep:	move.w	(a3)+,(a0)+		; Repeatsample
		addq.l	#1,d1
		dbra	d0,mt_moverep
		cmp.l	#320,d1			; Must be > 320
		blt.s	mt_toosmal

		move.w	#320/2-1,d0
mt_last320:	move.w	(a2)+,(a0)+		; Safety 320 bytes
		dbra	d0,mt_last320

		move.w	d4,$2a(a1)		; Length
		move.w	d1,$30(a1)		; Replen
		clr.w	$2E(a1)

mt_samplok:	lea	$1E(a1),a1
		movea.l	(sp)+,a2
		move.w	(sp)+,d0
		dbra	d0,mt_roop

		rts

mt_end_of_samples:DC.L 0
mt_totalsize:	DC.L 0

;------------------------------------------------------ Main replayrout --
n_note		EQU 0		; W
n_cmd		EQU 2		; W
n_cmdlo 	EQU 3		; B
n_start 	EQU 4		; L
n_length	EQU 8		; W
n_loopstart	EQU 10		; L
n_replen	EQU 14		; W
n_period	EQU 16		; W
n_finetune	EQU 18		; B
n_volume	EQU 19		; B
n_dmabit	EQU 20		; W
n_toneportdirec EQU 22		; B
n_toneportspeed EQU 23		; B
n_wantedperiod	EQU 24		; W
n_vibratocmd	EQU 26		; B
n_vibratopos	EQU 27		; B
n_tremolocmd	EQU 28		; B
n_tremolopos	EQU 29		; B
n_wavecontrol	EQU 30		; B
n_glissfunk	EQU 31		; B
n_sampleoffset	EQU 32		; B
n_pattpos	EQU 33		; B
n_loopcount	EQU 34		; B
n_funkoffset	EQU 35		; B
n_wavestart	EQU 36		; L
n_reallength	EQU 40		; W

mt_init:	lea	mt_data(pc),a0
		lea	$03B8(a0),a1

		moveq	#$7F,d0
		moveq	#0,d4
mt_loop:	move.l	d4,d2
		subq.w	#1,d0
mt_lop2:	move.b	(a1)+,d4
		cmp.b	d2,d4
		bgt.s	mt_loop
		dbra	d0,mt_lop2
		addq.b	#1,d2

		lea	mt_samplestarts(pc),a1
		asl.l	#8,d2
		asl.l	#2,d2
		add.l	#$043C,d2
		move.l	d2,d1
		add.l	a0,d2
		movea.l	d2,a2

		moveq	#$1E,d0
mt_lop3:	clr.l	(a2)
		move.l	a2,(a1)+
		moveq	#0,d4
		move.w	42(a0),d4
		add.l	d4,d4
		adda.l	d4,a2
		adda.w	#$1E,a0
		dbra	d0,mt_lop3

		move.l	a2,mt_end_of_samples	;

mt_calcspc:	lea	mt_data(pc),a0
		moveq	#31-1,d4
		moveq	#0,d0

mt_nxtspl:	moveq	#0,d2

		tst.w	$2a(a0)
		beq.s	mt_nulspl		; Len=0 -> no sample

		tst.w	$2E(a0)			; Test repstrt
		bne.s	mt_repext		; Jump if zero

		move.w	$2a(a0),d2		; Length of sample
		cmp.w	$30(a0),d2
		bne.s	mt_repn

mt_repext:	move.w	$2E(a0),d2
mt_repn:	add.l	d2,d2
		add.l	d2,d0

		move.w	$30(a0),d2
		cmp.w	#320,d2
		bge.s	mt_repgok

		move.l	#320,d3
		divu	d2,d3
		swap	d3
		tst.w	d3
		beq.s	mt_exact
		swap	d3
		addq.w	#1,d3
		mulu	d3,d2
		bra.s	mt_repgok

mt_exact:	move.w	#320,d2
mt_repgok:	add.l	d2,d2
		add.l	d2,d0
		add.l	#320,d0

mt_nulspl:	lea	$1E(a0),a0
		dbra	d4,mt_nxtspl

		add.l	d0,d1
		move.l	d1,mt_totalsize
		rts



mt_music:	lea	mt_data(pc),a0
		move.w	mt_speed(pc),d0
		sub.w	d0,mt_counter
		bgt.s	mt_nonew
		move.w	mt_rescnt(pc),d0
		add.w	d0,mt_counter
		bra	mt_getnew

mt_nonew:	lea	mt_voice1(pc),a4
		lea	aud1lc(pc),a3
		bsr	mt_checkcom
		lea	mt_voice2(pc),a4
		lea	aud2lc(pc),a3
		bsr	mt_checkcom
		lea	mt_voice3(pc),a4
		lea	aud3lc(pc),a3
		bsr	mt_checkcom
		lea	mt_voice4(pc),a4
		lea	aud4lc(pc),a3
		bsr	mt_checkcom
		bra	mt_exit

mt_arpeggio:	moveq	#0,d0
		move.w	mt_rescnt(pc),d0
		sub.w	mt_counter(pc),d0
		move.w	mt_speed(pc),d1
		beq.s	mt_arp2

		divu	d1,d0
		swap	d0
		clr.w	d0
		swap	d0
		divu	#$0003,d0
		swap	d0
		tst.w	d0
		beq.s	mt_arp2
		cmp.w	#$0002,d0
		beq.s	mt_arp1

		moveq	#0,d0
		move.b	n_cmdlo(a4),d0
		lsr.b	#4,d0
		bra.s	mt_arp3

mt_arp1:	moveq	#0,d0
		move.b	n_cmdlo(a4),d0
		and.b	#$0F,d0
;		bra.s	mt_arp3

mt_arp3:	add.w	d0,d0
		moveq	#0,d1
		move.w	n_period(a4),d1
		lea	mt_periods(pc),a0

		moveq	#0,d3			;
		move.b	n_finetune(a4),d3	; Finetune
		mulu	#36*2,d3		;
		adda.w	d3,a0			;

		moveq	#$24,d4
mt_arploop:	move.w	0(a0,d0.w),d2
		cmp.w	(a0),d1
		bge.s	mt_arp4
		addq.l	#2,a0
		dbra	d4,mt_arploop
		rts

mt_arp2:	move.w	n_period(a4),d2
mt_arp4:	move.w	d2,$06(a3)
		rts

mt_getnew:	lea	mt_data+$043C(pc),a0
		lea	mt_data+$03B8(pc),a1
		lea	mt_data+$0C(pc),a2

		tst.b	mt_break		; SONG PLAY dIFFS
		beq.s	mt_nobr

		move.b	mt_jumppos(pc),mt_songpos
		bra.s	mt_nex			; Pattern break!

mt_nobr:	cmpi.w	#$0400,mt_pattpos
		bne.s	mt_endr
mt_nex:		clr.w	mt_pattpos
		clr.b	mt_break
		addq.b	#1,mt_songpos
		andi.b	#$7F,mt_songpos
		move.b	mt_songpos(pc),d1
		cmp.b	mt_data+$03B6(pc),d1
		bne.s	mt_endr
		move.b	mt_data+$03B7(pc),mt_songpos

mt_endr:	moveq	#0,d0
		moveq	#0,d1
		move.b	mt_songpos(pc),d0
		move.b	0(a1,d0.w),d1
		asl.l	#8,d1
		asl.l	#2,d1
		move.w	mt_pattpos(pc),d0
		add.w	d0,d1

		clr.w	mt_dmacon

		lea	aud1lc(pc),a3
		lea	mt_voice1(pc),a4
		bsr.s	mt_playvoice
		lea	aud2lc(pc),a3
		lea	mt_voice2(pc),a4
		bsr.s	mt_playvoice
		lea	aud3lc(pc),a3
		lea	mt_voice3(pc),a4
		bsr.s	mt_playvoice
		lea	aud4lc(pc),a3
		lea	mt_voice4(pc),a4
		bsr.s	mt_playvoice
		bra	mt_setdma

mt_playvoice:	move.l	0(a0,d1.l),(a4)
		addq.l	#4,d1
		moveq	#0,d2
		move.b	$02(a4),d2
		lsr.b	#4,d2
		move.b	(a4),d0
		and.b	#$F0,d0
		or.b	d0,d2
		beq	mt_setregs

		moveq	#0,d3
		lea	mt_samplestarts(pc),a1
		move.l	d2,d4
		subq.l	#$01,d2
		asl.l	#2,d2
		mulu	#$1E,d4
		move.l	0(a1,d2.l),n_start(a4)
		move.w	0(a2,d4.l),n_length(a4)
		move.w	$02(a2,d4.l),n_finetune(a4)
		move.w	$04(a2,d4.l),d3
		tst.w	d3
		beq.s	mt_noloop

		move.l	n_start(a4),d2
		add.w	d3,d3
		add.l	d3,d2
		move.l	d2,n_loopstart(a4)
		move.w	$04(a2,d4.l),d0

		add.w	$06(a2,d4.l),d0
		move.w	d0,8(a4)
		move.w	$06(a2,d4.l),n_replen(a4)
		move.b	n_volume(a4),9(a3)
		move.b	n_volume(a4),11(a3)
		st	10(a3)			; Indicate volume change
		move.w	d4,12(a3)		; Save splno.
		subi.w	#$1E,12(a3)		;
		bra.s	mt_setregs

mt_noloop:	move.l	n_start(a4),n_loopstart(a4)
		move.w	$06(a2,d4.l),n_replen(a4)
		move.b	n_volume(a4),9(a3)
		move.b	n_volume(a4),11(a3)
		st	10(a3)			; Indicate volume change
		move.w	d4,12(a3)		; Save splno.
		subi.w	#$1E,12(a3)		;

mt_setregs:	move.w	(a4),d0
		and.w	#$0FFF,d0
		beq	mt_checkcom2

		tst.b	n_finetune(a4)
		beq.s	mt_nofine
		lea	mt_periods(pc),a5
		moveq	#0,d2
		moveq	#35,d3

mt_perlook:	cmp.w	0(a5,d2.w),d0
		beq.s	mt_perfound
		addq.w	#2,d2
		dbra	d3,mt_perlook

mt_perfound:	moveq	#0,d3
		move.b	n_finetune(a4),d3
		mulu	#36*2,d3
		adda.w	d3,a5
		move.w	0(a5,d2.w),d0		; Finetune
		andi.w	#$F000,(a4)
		or.w	d0,(a4)

mt_nofine:	move.b	$02(a4),d0
		and.b	#$0F,d0
		cmp.b	#$03,d0
		bne.s	mt_setperiod
		bsr	mt_setmyport
		bra	mt_checkcom2

mt_setperiod:	move.w	(a4),d0
		and.w	#$0FFF,d0
		move.w	d0,n_period(a4)

		move.w	$14(a4),d0
		move.w	d0,dmactrl
		clr.b	$1B(a4)

		move.l	n_start(a4),(a3)
		move.w	n_length(a4),$04(a3)
		move.w	n_period(a4),d0
		and.w	#$0FFF,d0
		move.w	d0,$06(a3)
		move.w	$14(a4),d0
		or.w	d0,mt_dmacon
		bra	mt_checkcom2

mt_setdma:	move.w	mt_dmacon(pc),d0
		moveq	#0,d1

		btst	#0,d0			;-------------------
		beq.s	wz_nch1			;

		move.l	aud1lc(pc),rep1lc	;
		moveq	#0,d1			; 25 kHz stuff
		moveq	#0,d2			;
		move.w	aud1len(pc),d1		;
		add.l	d1,d1			;
		move.w	mt_voice1+$0E(pc),d2	;
		add.l	d2,d2			;
		add.l	d2,d1			;
		move.l	d2,rep1rpt		;
		add.l	aud1lc(pc),d1		;
		move.l	d1,rep1end		;

wz_nch1:	btst	#1,d0			;
		beq.s	wz_nch2			;

		move.l	aud2lc(pc),rep2lc	;
		moveq	#0,d1			; 25 kHz stuff
		moveq	#0,d2			;
		move.w	aud2len(pc),d1		;
		add.l	d1,d1			;
		move.w	mt_voice2+$0E(pc),d2	;
		add.l	d2,d2			;
		add.l	d2,d1			;
		move.l	d2,rep2rpt		;
		add.l	aud2lc(pc),d1		;
		move.l	d1,rep2end		;

wz_nch2:	btst	#2,d0			;
		beq.s	wz_nch3			;

		move.l	aud3lc(pc),rep3lc	;
		moveq	#0,d1			; 25 kHz stuff
		moveq	#0,d2			;
		move.w	aud3len(pc),d1		;
		add.l	d1,d1			;
		move.w	mt_voice3+$0E(pc),d2	;
		add.l	d2,d2			;
		add.l	d2,d1			;
		move.l	d2,rep3rpt		;
		add.l	aud3lc(pc),d1		;
		move.l	d1,rep3end		;

wz_nch3:	btst	#3,d0			;
		beq.s	wz_nch4			;

		move.l	aud4lc(pc),rep4lc	;
		moveq	#0,d1			; 25 kHz stuff
		moveq	#0,d2			;
		move.w	aud4len(pc),d1		;
		add.l	d1,d1			;
		move.w	mt_voice4+$0E(pc),d2	;
		add.l	d2,d2			;
		add.l	d2,d1			;
		move.l	d2,rep4rpt		;
		add.l	aud4lc(pc),d1		;
		move.l	d1,rep4end		;

wz_nch4:	addi.w	#$10,mt_pattpos
mt_exit:	rts

mt_setmyport:	move.w	(a4),d2
		and.w	#$0FFF,d2
		move.w	d2,$18(a4)
		move.w	n_period(a4),d0
		clr.b	$16(a4)

		cmp.w	d0,d2
		beq.s	mt_clrport
		bge.s	mt_rt
		move.b	#$01,$16(a4)
		rts

mt_clrport:	clr.w	$18(a4)
mt_rt:		rts

mt_myport:	move.b	n_cmdlo(a4),d0
		beq.s	mt_myslide
		move.b	d0,$17(a4)
		clr.b	n_cmdlo(a4)
mt_myslide:	tst.w	$18(a4)
		beq.s	mt_rt
		moveq	#0,d0
		move.b	$17(a4),d0
		tst.b	$16(a4)
		bne.s	mt_mysub
		add.w	d0,n_period(a4)
		move.w	$18(a4),d0
		cmp.w	n_period(a4),d0
		bgt.s	mt_myok
		move.w	$18(a4),n_period(a4)
		clr.w	$18(a4)

mt_myok:	move.w	n_period(a4),$06(a3)
		rts

mt_mysub:	sub.w	d0,n_period(a4)
		move.w	$18(a4),d0
		cmp.w	n_period(a4),d0
		blt.s	mt_myok
		move.w	$18(a4),n_period(a4)
		clr.w	$18(a4)
		move.w	n_period(a4),$06(a3)
		rts

mt_vib:		move.b	n_cmdlo(a4),d0
		move.b	d0,d2
		and.b	#$0F,d2
		beq.s	mt_vin1st
		and.b	#$F0,d0
		beq.s	mt_vi1st
		move.b	n_cmdlo(a4),$001A(a4)	; Only second digit != 0
		bra.s	mt_vi
mt_vi1st:	andi.b	#$F0,$001A(a4)		; Both digits != 0
		or.b	d2,$001A(a4)
		bra.s	mt_vi
mt_vin1st:	and.b	#$F0,d0
		beq.s	mt_vi
		andi.b	#$0F,$001A(a4)		; Only first digit != 0
		or.b	d0,$001A(a4)

mt_vi:		move.b	$1B(a4),d0
		lea	mt_sin(pc),a1
		lsr.w	#$02,d0
		and.w	#$1F,d0
		moveq	#0,d2
		move.b	0(a1,d0.w),d2
		move.b	$1a(a4),d0
		and.w	#$0F,d0
		mulu	d0,d2
		lsr.w	#$06,d2
		move.w	n_period(a4),d0
		tst.b	$1B(a4)
		bmi.s	mt_vibmin

		add.w	d2,d0
		bra.s	mt_vib2

mt_vibmin:	sub.w	d2,d0
mt_vib2:	move.w	d0,$06(a3)
		move.b	$1a(a4),d0
		lsr.w	#$02,d0
		and.w	#$3C,d0
		add.b	d0,$1B(a4)
		rts

mt_nop:		move.w	n_period(a4),$06(a3)
		rts

mt_checkcom:	move.w	$02(a4),d0
		and.w	#$0FFF,d0
		beq.s	mt_nop
		move.b	$02(a4),d0
		and.b	#$0F,d0
		tst.b	d0
		beq	mt_arpeggio
		cmp.b	#$01,d0
		beq	mt_portup
		cmp.b	#$02,d0
		beq	mt_portdown
		cmp.b	#$03,d0
		beq	mt_myport
		cmp.b	#$04,d0
		beq	mt_vib
		cmp.b	#$05,d0
		beq.s	mt_port_volslide
		cmp.b	#$06,d0
		beq.s	mt_vib_volslide
		move.w	n_period(a4),$06(a3)

		cmp.b	#$0a,d0
		beq.s	mt_volslide
		rts

mt_port_volslide:
		bsr	mt_myslide
		bra.s	mt_volslide

mt_vib_volslide:bsr	mt_vi
;		bra.s	mt_volslide

mt_volslide:	moveq	#0,d0			; Volume slide
		move.b	n_cmdlo(a4),d0
		lsr.b	#4,d0
		tst.b	d0
		beq.s	mt_voldown
mt_volup:	add.b	d0,n_volume(a4)
		cmpi.b	#$40,n_volume(a4)
		bmi.s	mt_vol2
		move.b	#$40,n_volume(a4)
mt_vol2:	move.b	n_volume(a4),$09(a3)
		rts

mt_voldown:	moveq	#0,d0
		move.b	n_cmdlo(a4),d0
		and.b	#$0F,d0
		sub.b	d0,n_volume(a4)
		bpl.s	mt_vol3
		clr.b	n_volume(a4)
mt_vol3:	move.b	n_volume(a4),$09(a3)
		rts

mt_fineportaup:	move.b	n_cmdlo(a4),d0
		and.w	#$0F,d0
		move.w	mt_counter(pc),d4
		cmp.w	mt_rescnt(pc),d4
		beq.s	mt_pue
		rts
mt_portup:	moveq	#0,d0
		move.b	n_cmdlo(a4),d0
mt_pue:		sub.w	d0,n_period(a4)
		move.w	n_period(a4),d0
		and.w	#$0FFF,d0
		cmp.w	#$71,d0
		bpl.s	mt_por2
		andi.w	#$F000,n_period(a4)
		ori.w	#$71,n_period(a4)
mt_por2:	move.w	n_period(a4),d0
		and.w	#$0FFF,d0
		move.w	d0,$06(a3)
		rts


mt_fineportadown:
		move.b	n_cmdlo(a4),d0
		and.w	#$0F,d0
		move.w	mt_counter(pc),d4
		cmp.w	mt_rescnt(pc),d4
		beq.s	mt_pde
		rts
mt_portdown:	moveq	#0,d0
		move.b	n_cmdlo(a4),d0
mt_pde:		add.w	d0,n_period(a4)
		move.w	n_period(a4),d0
		and.w	#$0FFF,d0
		cmp.w	#$0358,d0
		bmi.s	mt_por3
		andi.w	#$F000,n_period(a4)
		ori.w	#$0358,n_period(a4)
mt_por3:	move.w	n_period(a4),d0
		and.w	#$0FFF,d0
		move.w	d0,$06(a3)
		rts

mt_checkcom2:	move.b	$02(a4),d0		; Check for commands
		and.b	#$0F,d0
		cmp.b	#$0E,d0
		beq	mt_e_commands
		cmp.b	#$0d,d0
		beq.s	mt_pattbreak
		cmp.b	#$0B,d0
		beq.s	mt_posjmp
		cmp.b	#$09,d0
		beq.s	mt_setpos
		cmp.b	#$0C,d0
		beq.s	mt_setvol
		cmp.b	#$0F,d0
		beq.s	mt_setspeed
		rts

mt_setpos:	moveq	#0,d0
		move.b	n_cmdlo(a4),d0
		lsl.w	#8,d0
		moveq	#0,d2
		move.w	n_length(a4),d2
		add.l	d2,d2
		sub.l	d0,d2
		ble.s	no_msp
		lsr.l	#1,d2
		move.w	d2,n_length(a4)
		add.l	d0,n_start(a4)
		move.l	n_start(a4),(a3)
		move.w	d2,4(a3)
no_msp:		rts

mt_pattbreak:	st	mt_break
		move.b	mt_songpos(pc),mt_jumppos
		rts

mt_posjmp:	move.b	n_cmdlo(a4),d0
		subq.b	#$01,d0
		move.b	d0,mt_jumppos
		st	mt_break
		rts

mt_setvol:	moveq	#0,d0
		move.b	n_cmdlo(a4),d0
		cmp.w	#$40,d0
		ble.s	mt_vol4
		move.b	#$40,n_cmdlo(a4)
mt_vol4:	move.b	n_cmdlo(a4),$09(a3)
		move.b	n_cmdlo(a4),n_volume(a4)
		rts

mt_setspeed:	moveq	#0,d0
		move.b	n_cmdlo(a4),d0
		cmp.w	#32,d0
		bge.s	.bpm

		move.w	d0,mt_pspeed
		bra.s	mt_speedcalc
.bpm:		move.w	d0,mt_cia

mt_speedcalc:	move.w	mt_cia(pc),d0
		move.w	d0,mt_speed

		move.w	#vfreq*60*24/9/64,d0
		mulu	mt_pspeed(pc),d0
		move.w	d0,mt_counter
		move.w	d0,mt_rescnt
		rts

mt_e_commands:	move.b	n_cmdlo(a4),d0
		and.b	#$F0,d0
		lsr.b	#4,d0
		cmp.b	#1,d0
		beq	mt_fineportaup
		cmp.b	#2,d0
		beq	mt_fineportadown
		cmp.b	#5,d0
		beq.s	mt_setfinetune
		cmp.b	#$0a,d0
		beq.s	mt_volumefineup
		cmp.b	#$0B,d0
		beq.s	mt_volumefinedown
		rts

mt_setfinetune:	move.b	n_cmdlo(a4),d0
		and.b	#$0F,d0
		move.b	d0,n_finetune(a4)
		rts

mt_volumefineup:moveq	#0,d0
		move.b	n_cmdlo(a4),d0
		and.b	#$0F,d0
		move.w	mt_counter(pc),d4
		cmp.w	mt_rescnt(pc),d4
		beq	mt_volup
		rts

mt_volumefinedown:
		move.w	mt_counter(pc),d0
		cmp.w	mt_rescnt(pc),d0
		beq	mt_voldown
		rts


mt_sin:		DC.B 0,24,49,74,97,120,141,161
		DC.B 180,197,212,224,235,244,250,253
		DC.B 255,253,250,244,235,224,212,197
		DC.B 180,161,141,120,97,74,49,24

mt_periods:
; Tuning 0, Normal
		DC.W 856,808,762,720,678,640,604,570,538,508,480,453
		DC.W 428,404,381,360,339,320,302,285,269,254,240,226
		DC.W 214,202,190,180,170,160,151,143,135,127,120,113
; Tuning 1
		DC.W 850,802,757,715,674,637,601,567,535,505,477,450
		DC.W 425,401,379,357,337,318,300,284,268,253,239,225
		DC.W 213,201,189,179,169,159,150,142,134,126,119,113
; Tuning 2
		DC.W 844,796,752,709,670,632,597,563,532,502,474,447
		DC.W 422,398,376,355,335,316,298,282,266,251,237,224
		DC.W 211,199,188,177,167,158,149,141,133,125,118,112
; Tuning 3
		DC.W 838,791,746,704,665,628,592,559,528,498,470,444
		DC.W 419,395,373,352,332,314,296,280,264,249,235,222
		DC.W 209,198,187,176,166,157,148,140,132,125,118,111
; Tuning 4
		DC.W 832,785,741,699,660,623,588,555,524,495,467,441
		DC.W 416,392,370,350,330,312,294,278,262,247,233,220
		DC.W 208,196,185,175,165,156,147,139,131,124,117,110
; Tuning 5
		DC.W 826,779,736,694,655,619,584,551,520,491,463,437
		DC.W 413,390,368,347,328,309,292,276,260,245,232,219
		DC.W 206,195,184,174,164,155,146,138,130,123,116,109
; Tuning 6
		DC.W 820,774,730,689,651,614,580,547,516,487,460,434
		DC.W 410,387,365,345,325,307,290,274,258,244,230,217
		DC.W 205,193,183,172,163,154,145,137,129,122,115,109
; Tuning 7
		DC.W 814,768,725,684,646,610,575,543,513,484,457,431
		DC.W 407,384,363,342,323,305,288,272,256,242,228,216
		DC.W 204,192,181,171,161,152,144,136,128,121,114,108
; Tuning -8
		DC.W 907,856,808,762,720,678,640,604,570,538,508,480
		DC.W 453,428,404,381,360,339,320,302,285,269,254,240
		DC.W 226,214,202,190,180,170,160,151,143,135,127,120
; Tuning -7
		DC.W 900,850,802,757,715,675,636,601,567,535,505,477
		DC.W 450,425,401,379,357,337,318,300,284,268,253,238
		DC.W 225,212,200,189,179,169,159,150,142,134,126,119
; Tuning -6
		DC.W 894,844,796,752,709,670,632,597,563,532,502,474
		DC.W 447,422,398,376,355,335,316,298,282,266,251,237
		DC.W 223,211,199,188,177,167,158,149,141,133,125,118
; Tuning -5
		DC.W 887,838,791,746,704,665,628,592,559,528,498,470
		DC.W 444,419,395,373,352,332,314,296,280,264,249,235
		DC.W 222,209,198,187,176,166,157,148,140,132,125,118
; Tuning -4
		DC.W 881,832,785,741,699,660,623,588,555,524,494,467
		DC.W 441,416,392,370,350,330,312,294,278,262,247,233
		DC.W 220,208,196,185,175,165,156,147,139,131,123,117
; Tuning -3
		DC.W 875,826,779,736,694,655,619,584,551,520,491,463
		DC.W 437,413,390,368,347,328,309,292,276,260,245,232
		DC.W 219,206,195,184,174,164,155,146,138,130,123,116
; ning -2
		DC.W 868,820,774,730,689,651,614,580,547,516,487,460
		DC.W 434,410,387,365,345,325,307,290,274,258,244,230
		DC.W 217,205,193,183,172,163,154,145,137,129,122,115
; Tuning -1
		DC.W 862,814,768,725,684,646,610,575,543,513,484,457
		DC.W 431,407,384,363,342,323,305,288,272,256,242,228
		DC.W 216,203,192,181,171,161,152,144,136,128,121,114

mt_cia:		DC.W 125
mt_pspeed:	DC.W 6

mt_speed:	DC.W 125
mt_counter:	DC.W vfreq*60*6*24/9/64
mt_rescnt:	DC.W vfreq*60*6*24/9/64

mt_pattpos:	DC.W 0
mt_songpos:	DC.B 0
		EVEN

mt_samplestarts:DS.L 31
mt_samplelengths:DS.L 31

mt_jumppos:	DC.B 0
mt_break:	DC.B 0
mt_dmacon:	DC.W 0

mt_voice1:	DC.L 0
		DC.L dummy
		DC.W 0		; Length

		DC.L dummy
		DC.W 1		; Replen
		DC.W 1		; Period
		DC.W 0
		DC.W $01
		DS.W 3
		DC.L 0		;

mt_voice2:	DC.L 0
		DC.L dummy
		DC.W 0		; Length
		DC.L dummy
		DC.W 1		; Replen
		DC.W 1		; Period
		DC.W 0
		DC.W $02
		DS.W 3
		DC.L 0		;

mt_voice3:	DC.L 0
		DC.L dummy
		DC.W 0		; Length
		DC.L dummy
		DC.W 1		; Replen
		DC.W 1		; Period
		DC.W 0
		DC.W $04

		DS.W 3
		DC.L 0		;

mt_voice4:	DC.L 0
		DC.L dummy
		DC.W 0		; Length
		DC.L dummy

		DC.W 1		; Replen
		DC.W 1		; Period
		DC.W 0
		DC.W $08
		DS.W 3
		DC.L 0		;
